#include "system.h"
#include "smalltask.h"
#include "Control.h"

uint8_t led_count = 0;

static void heartbeat (void)    //PWM of leds to generate a heartbeat effect
{
#	define MAX_PER 20
#	define PRE 40
	static int pre = 0;
	static int dir = 1;
	static int cnt = 0;
	static int ds = 0;
	static int hb = 2;
	static int teller = 0;
//	CPY_amb_led_R(cnt < ds);
    
    if (cnt < ds)
    {
        CLR_LED1();
        CLR_LED2();
        CLR_LED3();
        CLR_LED4();
    }
    else
	{
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
	}
    
	if (hb > 0)
	{
		if (cnt < MAX_PER)
			cnt++;
		else
			cnt = 0;
		if (pre < PRE)
		{
			pre++;
		}
		else
		{
			ds += dir;
			if (ds >= MAX_PER)
			{
				dir = -1;
			}
			else if (ds <= 0)
			{
				dir = 1;
				hb--;
			}
			pre = 0;
		}
	}
	else
	{
		teller++;
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
		if (teller >= 2200)
		{
			teller = 0;
			hb = 2;
		}
	}
		
#	undef PRE
#	undef MAX_PER	
}



//void ledcircle(int PRE)
//{
//#	define MAX_PER 20
//	static int pre = 0;
//	static int dir = 1;
//	static int cnt = 0;
//	static int ds = 0;   
//    static int pre2 = 0;
//	static int dir2 = 1;
//	static int ds2 = 10;
// 
//    if (cnt < ds){
//        SET_LED1();
//        CLR_LED3();
//    }
//    else
//	{
//        CLR_LED1();
//        SET_LED3();
//	}
//    
//    if (cnt < MAX_PER)
//        cnt++;
//    else
//        cnt = 0;
//    
//    if (pre < PRE)
//    {
//        pre++;
//    }
//    else
//    {
//        ds += dir;
//        if (ds >= MAX_PER)
//            dir = -1;
//        else if (ds <= 0)
//            dir = 1;
//        pre = 0;
//	}	
//    
//    if (cnt < ds2){
//        SET_LED2();
//        CLR_LED4();
//    }
//    else
//	{
//        CLR_LED2();
//        SET_LED4();
//	}
//    
//    if (pre2 < PRE)
//    {
//        pre2++;
//    }
//    else
//    {
//        ds2 += dir2;
//        if (ds2 >= MAX_PER)
//        {
//            dir2 = -1;
//        }
//        else if (ds2 <= 0)
//        {
//            dir2 = 1;
//        }
//        pre2 = 0;
//	}
//#	undef MAX_PER    
//}


void ledcircle2(int PRE)    //makes leds go around
{
#	define MAX_PER 20

	static int pre = 0;
	static int dir = 1;
	static int cnt = 0;
	static int ds = 0;
    static int step = 0;

 
    if ((cnt < ds) && (step == 0)){
        CLR_LED1();
    }
    else if (step == 0)
	{
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
	}
    
    if ((cnt < ds) && (step == 1)){
        CLR_LED2();
    }
    else if (step == 1)
	{
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
	}
    
    if ((cnt < ds) && (step == 2)){
        CLR_LED3();
    }
    else if (step == 2)
	{
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
	}
    
    if ((cnt < ds) && (step == 3)){
        CLR_LED4();
    }
    else if (step == 3)
	{
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
	}
    
    if (cnt < MAX_PER)
        cnt++;
    else
        cnt = 0;
    
    if (pre < PRE)
    {
        pre++;
    }
    else
    {
        ds += dir;
        if (ds >= MAX_PER)
            dir = -1;
        else if (ds <= 0)
        {
            dir = 1;
            step++;
            if (step>3)
                step=0;
        }   
        pre = 0;
	}	
#	undef MAX_PER    
}


void Led_task(void)     // change led lighting accoding to states
{
    if((Control_state < 2) || (darkmode == true))
    {
        SET_LED1();
        SET_LED2();
        SET_LED3();
        SET_LED4();
    }
    else if (Control_state == 2)
    {
        heartbeat();
    }       
    else if (Control_state > 4)
    {
        ledcircle2(50);
    }
    else if (Control_state > 3)
    {
        ledcircle2(55);
    }
    else if (Control_state > 2)
    {
        ledcircle2(60);
    }
    else 
    {
        ledcircle2(60);
    }
    Smalltask_rerun(TASK_Led_task, 2);
}
