#define STRUCKT_NOT_WORKING

#include "system.h"
#include "smalltask.h"
//#include "app_device_cdc_basic.h"
#include "LED.h"
#include "Control.h"
#include <xc.h>

//==========================================================================================
// Definitions
//==========================================================================================
#define SMALLTASK_TIMMERREGISTER TMR0L


//==========================================================================================
// Types
//==========================================================================================

//==========================================================================================
// Global Values
//==========================================================================================
bool Smalltask_Check[SMALLTASK_TASK_COUNT];
bool Smalltask_Use_Counter[SMALLTASK_TASK_COUNT];
//union smalltask_time_function_u Smalltask_Time[SMALLTASK_TASK_COUNT];
uint16_t Smalltask_Time[SMALLTASK_TASK_COUNT];

uint16_t Smaltask_Uptime_ms;
uint32_t Smaltask_Uptime_s;
uint32_t Smalltask_Unixtime;

//==========================================================================================
// Internal Values
//==========================================================================================
uint8_t smalltask_timeroverflow;
void Smalltask_run( uint8_t task );
//==========================================================================================
// Interrupts
//==========================================================================================
void Smalltask_interupt(void)
{
    SMALLTASK_TIMMERREGISTER += 163;
    smalltask_timeroverflow++;
}
//==========================================================================================
// Internal Functions
//==========================================================================================
void Smalltask_run( uint8_t task )
{
	switch (task)
	{
#define TASK(a) case  TASK_##a: a(); break;
	SMALLTASK_TASK;
#undef TASK
	}
}
//==========================================================================================
// Global Functions
//==========================================================================================
void Smalltask_init( void ) //set interrups and timers for tasktimer
{
    smalltask_timeroverflow = 0;
    
    SMALLTASK_TIMMERREGISTER = 0;
	//set counter
    T0CON = _T0CON_T08BIT_MASK | _T0CON_T0PS0_MASK | _T0CON_T0PS1_MASK | _T0CON_T0PS0_MASK ;
	//clear interupt flag
    INTCON &= ~_INTCON_TMR0IF_MASK;
    //Turn timer on
    T0CON |= _T0CON_TMR0ON_MASK;
    INTCON |= _INTCON_T0IE_MASK;
}


void Smalltask_dispatch( void )
{
	uint8_t i;

	if( smalltask_timeroverflow )
	{
        smalltask_timeroverflow--;

		//Do task
		for(i = 0; i < SMALLTASK_TASK_COUNT ; i++)
		{

            if ( Smalltask_Check[i] )
            {
				if ( Smalltask_Use_Counter[i] )
				{                
                    if ( Smalltask_Time[i] == 0 )
                    {
                        Smalltask_Check[i] = false;
                        Smalltask_run(i);
                    }
                    else
                         Smalltask_Time[i]--;
                }
            }
            else
            {

            }                  
		}
    }
}

void Smalltask_rerun(uint8_t task, uint16_t time)
{
    Smalltask_Use_Counter[task] = true;
    Smalltask_Time[task] = time;
    Smalltask_Check[task] = true;
}

//void Smalltask_setfunc(uint8_t task, bool (*func)( void ))
//{
//    Smalltask_Use_Counter[task] = false;
////    Smalltask_Time[task] = func;
//    Smalltask_Check[task] = true;
//}
